"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.setCollectionV2 = exports.getSetCollectionV2InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getSetCollectionV2InstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 8 })],
        ['root', (0, serializers_1.bytes)({ size: 32 })],
        ['assetDataHash', (0, serializers_1.option)((0, serializers_1.bytes)({ size: 32 }))],
        ['flags', (0, serializers_1.option)((0, serializers_1.u8)())],
        ['nonce', (0, serializers_1.u64)()],
        ['index', (0, serializers_1.u32)()],
        ['metadata', (0, types_1.getMetadataArgsV2Serializer)()],
    ], { description: 'SetCollectionV2InstructionData' }), (value) => ({ ...value, discriminator: [229, 35, 61, 91, 15, 14, 99, 160] }));
}
exports.getSetCollectionV2InstructionDataSerializer = getSetCollectionV2InstructionDataSerializer;
// Instruction.
function setCollectionV2(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplBubblegum', 'BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY');
    // Accounts.
    const resolvedAccounts = {
        treeConfig: {
            index: 0,
            isWritable: false,
            value: input.treeConfig ?? null,
        },
        payer: { index: 1, isWritable: false, value: input.payer ?? null },
        authority: { index: 2, isWritable: false, value: input.authority ?? null },
        newCollectionAuthority: {
            index: 3,
            isWritable: false,
            value: input.newCollectionAuthority ?? null,
        },
        leafOwner: { index: 4, isWritable: false, value: input.leafOwner ?? null },
        leafDelegate: {
            index: 5,
            isWritable: false,
            value: input.leafDelegate ?? null,
        },
        merkleTree: { index: 6, isWritable: true, value: input.merkleTree ?? null },
        coreCollection: {
            index: 7,
            isWritable: true,
            value: input.coreCollection ?? null,
        },
        newCoreCollection: {
            index: 8,
            isWritable: true,
            value: input.newCoreCollection ?? null,
        },
        mplCoreCpiSigner: {
            index: 9,
            isWritable: false,
            value: input.mplCoreCpiSigner ?? null,
        },
        logWrapper: {
            index: 10,
            isWritable: false,
            value: input.logWrapper ?? null,
        },
        compressionProgram: {
            index: 11,
            isWritable: false,
            value: input.compressionProgram ?? null,
        },
        mplCoreProgram: {
            index: 12,
            isWritable: false,
            value: input.mplCoreProgram ?? null,
        },
        systemProgram: {
            index: 13,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.treeConfig.value) {
        resolvedAccounts.treeConfig.value = (0, accounts_1.findTreeConfigPda)(context, {
            merkleTree: (0, shared_1.expectPublicKey)(resolvedAccounts.merkleTree.value),
        });
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.mplCoreCpiSigner.value) {
        resolvedAccounts.mplCoreCpiSigner.value = (0, umi_1.publicKey)('CbNY3JiXdXNE9tPNEk1aRZVEkWdj2v7kfJLNQwZZgpXk');
    }
    if (!resolvedAccounts.logWrapper.value) {
        resolvedAccounts.logWrapper.value = context.programs.getPublicKey('splNoop', 'noopb9bkMVfRPU8AsbpTUg8AQkHtKwMYZiFUjNRtMmV');
        resolvedAccounts.logWrapper.isWritable = false;
    }
    if (!resolvedAccounts.compressionProgram.value) {
        resolvedAccounts.compressionProgram.value = context.programs.getPublicKey('splAccountCompression', 'cmtDvXumGCrqC1Age74AVPhSRVXJMd8PJS91L8KbNCK');
        resolvedAccounts.compressionProgram.isWritable = false;
    }
    if (!resolvedAccounts.mplCoreProgram.value) {
        resolvedAccounts.mplCoreProgram.value = context.programs.getPublicKey('mplCore', 'CoREENxT6tW1HoK8ypY1SxRMZTcVPm7R94rH4PZNhX7d');
        resolvedAccounts.mplCoreProgram.isWritable = false;
    }
    if (!resolvedAccounts.systemProgram.value) {
        resolvedAccounts.systemProgram.value = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
        resolvedAccounts.systemProgram.isWritable = false;
    }
    if (!resolvedArgs.assetDataHash) {
        resolvedArgs.assetDataHash = (0, umi_1.none)();
    }
    if (!resolvedArgs.flags) {
        resolvedArgs.flags = (0, umi_1.none)();
    }
    if (!resolvedArgs.proof) {
        resolvedArgs.proof = [];
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Remaining Accounts.
    const remainingAccounts = resolvedArgs.proof.map((value, index) => ({
        index,
        value,
        isWritable: false,
    }));
    orderedAccounts.push(...remainingAccounts);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getSetCollectionV2InstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.setCollectionV2 = setCollectionV2;
//# sourceMappingURL=setCollectionV2.js.map